function updateBlackholes()
	blackholeAttraction()
	blackHoleTimer()
end

function blackHoleTimer()
	for i, blackhole in ipairs(blackholes) do
		if blackhole.timer == nil then
			blackhole.timer = 0
		end
		blackhole.timer = blackhole.timer + hdt
		
		--remove blackhole
		if blackhole.timer > 30 then
			table.remove(blackholes,i)
		end
	end
end

function blackholeAttraction()
	for i, blackhole in ipairs(blackholes) do
		--attract player
		if getDistance(player.x,player.y,blackhole.x,blackhole.y) < blackhole.radius then
			newImpulse = {dir = getAngle(blackhole.x,blackhole.y,player.x,player.y)-math.rad(90),intensity = blackhole.radius-getDistance(player.x,player.y,blackhole.x,blackhole.y)+(blackhole.radius*0.1),id = 0} table.insert(impulses,newImpulse)
		end
		
		--attract enemies
		for j, enemy in ipairs(enemies) do
			if getDistance(enemy.x,enemy.y,blackhole.x,blackhole.y) < blackhole.radius then
				newImpulse = {dir = getAngle(blackhole.x,blackhole.y,enemy.x,enemy.y)-math.rad(90),intensity = blackhole.radius-getDistance(enemy.x,enemy.y,blackhole.x,blackhole.y)+(blackhole.radius*0.1),id = enemy.id} table.insert(impulses,newImpulse)
			end
		end
		
		--attract bullets
		for j, bullet in ipairs(bullets) do
			if getDistance(bullet.x,bullet.y,blackhole.x,blackhole.y) < blackhole.radius then
				newImpulse = {dir = getAngle(blackhole.x,blackhole.y,bullet.x,bullet.y)-math.rad(90),intensity = (blackhole.radius-getDistance(bullet.x,bullet.y,blackhole.x,blackhole.y))*10+(blackhole.radius*0.1),id = bullet.id} table.insert(impulses,newImpulse)
			end
		end
		
		--attract particles
		for j, particle in ipairs(particles) do
			if getDistance(particle.x,particle.y,blackhole.x,blackhole.y) < blackhole.radius then
				newImpulse = {dir = getAngle(blackhole.x,blackhole.y,particle.x,particle.y)-math.rad(90),intensity = blackhole.radius-getDistance(particle.x,particle.y,blackhole.x,blackhole.y)+(blackhole.radius*0.1),id = particle.id} table.insert(impulses,newImpulse)
			end
		end
		
		
	end
end