function updateEnemies()
	enemyNils()
	moveEnemies()
	killEnemies()
	enemyFighterAi()
	enemyHunterAi()
	enemyMineAi()
	enemyCollision()
end

function enemyNils()
	for i, enemy in ipairs(enemies) do
		--color
		if enemy.r == nil or enemy.g == nil or enemy.b == nil then
			enemy.r = sColor.r
			enemy.g = sColor.r
			enemy.b = sColor.r
		end
		--vector
		if enemy.dir == nil or enemy.velocity == nil then
			enemy.dir = 0
			enemy.velocity = 0
		end
		--health
		if enemy.health == nil then
			if enemy.eType == 1 then
				enemy.health = 45
			elseif enemy.eType == 3 then
				enemy.health = 55
			else
				enemy.health = 15
			end
		end
		--points and fuel and stuff
		if enemy.fuelGain == nil then
			if enemy.eType == 1 then
				enemy.fuelGain = 0.1/2.5
				enemy.scoreGain = 500
			elseif enemy.eType == 2 then
				enemy.fuelGain = 0.1/2.5
				enemy.scoreGain = 150
			elseif enemy.eType == 3 then
				enemy.fuelGain = 0.15/2.5
				enemy.scoreGain = 300
			else
				enemy.fuelGain = 0.05/2.5
				enemy.scoreGain = 100
			end
		end
		--hit
		if enemy.hit == nil then
			enemy.hit = 0
		end
		--shootTimer
		if enemy.shootTimer == nil then
			enemy.shootTimer = 0
			enemy.shootTimer2 = 0
			enemy.shootCounter = 0
		end
		
	end
end

function moveEnemies()
	for i, enemy in ipairs(enemies) do
		enemy.x = enemy.x + math.cos(enemy.dir)*enemy.velocity*hdt
		enemy.y = enemy.y + math.sin(enemy.dir)*enemy.velocity*hdt
	end
end

function killEnemies()
	for i, enemy in ipairs(enemies) do
		if enemy.health < 1 then
			--add explosion
			if enemy.eType == 1 then
				newExplosion = {x = enemy.x,y = enemy.y,radius = 50} table.insert(explosions,newExplosion)
			elseif enemy.eType == 2 then
				newExplosion = {x = enemy.x,y = enemy.y,radius = 85} table.insert(explosions,newExplosion)
			elseif enemy.eType == 4 then
				newExplosion = {x = enemy.x,y = enemy.y,radius = enemy.radius} table.insert(explosions,newExplosion)
			else
				newExplosion = {x = enemy.x,y = enemy.y,radius = 15} table.insert(explosions,newExplosion)
			end
			--add particles
			local n = math.random(5,8)
			local pId = 0
			if enemy.killedByPlayer then pId = 101 end	--add fuel particles if killed by player
			while n > 0 do
				newParticle = {id = math.random(1,10^21),x = enemy.x+math.random(-10,10),y = enemy.y+math.random(-10,10),dir = 0,velocity = 0,pType = pId} table.insert(particles,newParticle)
				n = n - 1
			end
			--add health pack
			if math.random(1,15) == 1 then
				newParticle = {id = math.random(1,10^21),x = enemy.x+math.random(-10,10),y = enemy.y+math.random(-10,10),dir = 0,velocity = 0,pType = 100} table.insert(particles,newParticle)
			end
			--shake screen
			if enemy.killedByPlayer then
				shakeFadeAmmount = 55
				shakeFade = 14
			end
			--remove enemy
			table.remove(enemies,i)
		end
	end
end

function enemyFighterAi()
	for i, enemy in ipairs(enemies) do
		if enemy.eType == 1 then
			--print(enemy.shootTimer,enemy.shootTimer2,enemy.shootCounter)
		
			--moving
			enemyThrust(i,player.x+math.cos(player.dir)*75,player.y+math.sin(player.dir)*75,12)
			--shooting
			enemy.shootTimer = enemy.shootTimer + hdt
			enemy.shootTimer2 = enemy.shootTimer2 - hdt
			if enemy.shootTimer > 2.5 then
				if enemy.shootTimer2 < 0 then
					--fire
					fire(enemy.x+math.cos(enemy.dir)*15,enemy.y+math.sin(enemy.dir)*15, enemy.dir, false,10,1,0,450)
					enemy.shootTimer2 = 0.1
					enemy.shootCounter = enemy.shootCounter + 1
				end
				--stop firing
				if enemy.shootCounter > 2 then
					enemy.shootTimer = 0
				end
			else
				enemy.shootCounter = 0
				enemy.shootTimer2 = 0
			end
			
			
		end
	end
end

function enemyHunterAi()
	for i, enemy in ipairs(enemies) do
		if enemy.eType == 3 then
			--moving
			enemyThrust(i,player.x+math.cos(player.dir)*10,player.y+math.sin(player.dir)*10,10)
			
			--shooting
			enemy.shootTimer = enemy.shootTimer + hdt
			if enemy.shootTimer > 2 then
				fire(enemy.x,enemy.y, getAngle(enemy.x,enemy.y,player.x,player.y), false,10,1,0,140, true,25)
				enemy.shootTimer = 0
			end
		end		
	end
end

function enemyMineAi()
	for i, enemy in ipairs(enemies) do
		if enemy.eType == 4 then
			--nils
			if enemy.armed == nil then
				enemy.armed = false
			end
			if enemy.aTimer == nil then
				enemy.aTimer = 0.75
			end
			if enemy.radius == nil then
				enemy.radius = 75
			end
			
			--see if the player is within the radius
			if getDistance(enemy.x,enemy.y,player.x,player.y) < enemy.radius then
				enemy.armed = true
			end
			
			--detonate
			if enemy.armed then
				enemy.aTimer = enemy.aTimer - hdt
				if enemy.aTimer < 0 then
					newExplosion = {x = enemy.x,y = enemy.y,radius = enemy.radius} table.insert(explosions,newExplosion)
					enemy.health = 0
				end
			end
			
		end
	end
end

function enemyThrust(i2,tx,ty,thrust)
	for i, enemy in ipairs(enemies) do
		if i == i2 then
			newImpulse = {dir = getAngle(enemy.x,enemy.y,tx,ty)+math.rad(90),intensity = thrust,id = enemy.id} table.insert(impulses,newImpulse)
		end
	end
end

function enemyCollision()
	--enemy on enemy collision
	for i, enemy in ipairs(enemies) do
		if enemy.x > -15 and enemy.x < 640+15 and enemy.y > - 15 and enemy.y < 360+15 then
			for j, enemy2 in ipairs(enemies) do
				if i == j then else
					if getDistance(enemy.x,enemy.y,enemy2.x,enemy2.y) < (8+8) then
						enemy.health = 0
						enemy2.health = 0
					end
				end
			end
			--player collision
			if getDistance(enemy.x,enemy.y,player.x,player.y) < (8+8) then
				enemy.health = 0
				player.hitTimer = 2
				newImpulse = {dir = enemy.dir, intensity = enemy.velocity, id = 0} table.insert(impulses,newImpulse)
			end
			
		end	
	end
end