function updateExplosions()
	explosionsNils()
	damagePlayer()
	explosionRepulsion()
	updateExplosionTimer()
	explosionDamageEnemies()
end

function explosionsNils()
	for i, explosion in ipairs(explosions) do
		if explosion.timer == nil then
			explosion.timer = 1
			explosion.acceleration = 3
			explosion.startTimer = explosion.timer
			--add screenshake
			if getDistance(explosion.x,explosion.y,player.x,player.y) < 300 then
				if shakeFade < 8 then
					shakeFadeAmmount = 25
					shakeFade = 8
				end
			end
			--play audio
			if getDistance(player.x,player.y,explosion.x,explosion.y) < 400 then
				a_explosion:setPitch(math.random(85,115)/100)
				local volume = 1-(getDistance(player.x,player.y,explosion.x,explosion.y)*0.001)
				if volume < 0 then volume = 0 end
				a_explosion:setVolume(volume*Avolume*1.2)
				la.play(a_explosion:clone())
			end
		end
	end
end

function damagePlayer()
	for i, explosion in ipairs(explosions) do
		if getDistance(player.x,player.y,explosion.x,explosion.y) < explosion.radius and explosion.timer == explosion.startTimer then
			player.health = player.health - 1
		end
	end
end

function explosionDamageEnemies()
	for i, explosion in ipairs(explosions) do
		for j, enemy in ipairs(enemies) do
			if getDistance(enemy.x,enemy.y,explosion.x,explosion.y) < explosion.radius+8 then
				if explosion.friendly then
					enemy.health = 0
					player.visualFuelTimer = 0.25
					player.fuel = player.fuel + enemy.fuelGain
					player.totalFuel = player.totalFuel + enemy.scoreGain
				end
			end
		end
	end
end

function updateExplosionTimer()
	for i, explosion in ipairs(explosions) do
		explosion.timer = explosion.timer - (hdt*2*explosion.acceleration)
		explosion.acceleration = explosion.acceleration - (3*hdt)
		--kill it
		if explosion.timer < 0 then
			table.remove(explosions,i)
		end
	end
end

function explosionRepulsion()
	for i, explosion in ipairs(explosions) do
		if explosion.timer == explosion.startTimer then
			
			--repel player
			if getDistance(player.x,player.y,explosion.x,explosion.y) < explosion.radius then
				newImpulse = {dir = getAngle(explosion.x,explosion.y,player.x,player.y)-math.rad(90),intensity = -(explosion.radius-(getDistance(player.x,player.y,explosion.x,explosion.y)))*170,id = 0} table.insert(impulses,newImpulse)
			end
			
			--repel enemies
			for i, enemy in ipairs(enemies) do
				if getDistance(enemy.x,enemy.y,explosion.x,explosion.y) < explosion.radius then
					newImpulse = {dir = getAngle(explosion.x,explosion.y,enemy.x,enemy.y)-math.rad(90),intensity = -(explosion.radius-(getDistance(enemy.x,enemy.y,explosion.x,explosion.y)))*170,id = enemy.id} table.insert(impulses,newImpulse)
				end
			end
			
			--repel bullets
			for i, bullet in ipairs(bullets) do
				if getDistance(bullet.x,bullet.y,explosion.x,explosion.y) < explosion.radius then
					newImpulse = {dir = getAngle(explosion.x,explosion.y,bullet.x,bullet.y)-math.rad(90),intensity = -(explosion.radius-(getDistance(bullet.x,bullet.y,explosion.x,explosion.y)))*170,id = bullet.id} table.insert(impulses,newImpulse)
				end
			end
			
			--repel particles
			for i, particle in ipairs(particles) do
				if getDistance(particle.x,particle.y,explosion.x,explosion.y) < explosion.radius then
					newImpulse = {dir = getAngle(explosion.x,explosion.y,particle.x,particle.y)-math.rad(90),intensity = -(explosion.radius-(getDistance(particle.x,particle.y,explosion.x,explosion.y)))*170,id = particle.id} table.insert(impulses,newImpulse)
				end
			end
			
			
			
		end
	end
end