function updateImpulses()
	setNewImpulseStuff()
	setPlayerVector()
	setBulletVector()
	setEnemyVector()
	setParticleVector()
	impulses = {}
end

function setNewImpulseStuff()
	for i, impulse in ipairs(impulses) do
		if impulse.isNew == nil then
			impulse.dir = impulse.dir - math.rad(90)
			impulse.isNew = false
		end
	end
end

function setParticleVector()
	--set difference stuff
	for i, particle in ipairs(particles) do
		particle.difX = particle.x+math.cos(particle.dir)*particle.velocity
		particle.difY = particle.y+math.sin(particle.dir)*particle.velocity
	end
	
	--simulate difference
	for i, impulse in ipairs(impulses) do
		for j, particle in ipairs(particles) do
			if impulse.id == particle.id then
				--change the vector
				particle.difX = particle.difX + math.cos(impulse.dir)*impulse.intensity*hdt
				particle.difY = particle.difY + math.sin(impulse.dir)*impulse.intensity*hdt
				
				--remove impulse
				table.remove(impulses,i)
			end
		end
	end
	
	--add difference to particle vector
	for i, particle in ipairs(particles) do
		particle.dir = getAngle(particle.x,particle.y,particle.difX,particle.difY)
		particle.velocity = getDistance(particle.x,particle.y,particle.difX,particle.difY)
	end
	
end


function setEnemyVector()
	--set difference stuff
	for i, enemy in ipairs(enemies) do
		enemy.difX = enemy.x+math.cos(enemy.dir)*enemy.velocity
		enemy.difY = enemy.y+math.sin(enemy.dir)*enemy.velocity
	end
	
	--simulate difference
	for i, impulse in ipairs(impulses) do
		for j, enemy in ipairs(enemies) do
			if impulse.id == enemy.id then
				--change the vector
				enemy.difX = enemy.difX + math.cos(impulse.dir)*impulse.intensity*hdt
				enemy.difY = enemy.difY + math.sin(impulse.dir)*impulse.intensity*hdt
				
				--remove impulse
				table.remove(impulses,i)
			end
		end
	end
	
	--add difference to enemy vector
	for i, enemy in ipairs(enemies) do
		enemy.dir = getAngle(enemy.x,enemy.y,enemy.difX,enemy.difY)
		enemy.velocity = getDistance(enemy.x,enemy.y,enemy.difX,enemy.difY)
	end
	
end

function setBulletVector()
	--set difference stuff
	for i, bullet in ipairs(bullets) do
		bullet.difX = bullet.x+math.cos(bullet.dir)*bullet.speed
		bullet.difY = bullet.y+math.sin(bullet.dir)*bullet.speed
	end
	
	--simulate difference
	for i, impulse in ipairs(impulses) do
		for j, bullet in ipairs(bullets) do
			if impulse.id == bullet.id then
				--change the vector
				bullet.difX = bullet.difX + math.cos(impulse.dir)*impulse.intensity*hdt
				bullet.difY = bullet.difY + math.sin(impulse.dir)*impulse.intensity*hdt
				
				--remove impulse
				table.remove(impulses,i)
			end
		end
	end
	
	--add difference to bullet vector
	for i, bullet in ipairs(bullets) do
		bullet.dir = getAngle(bullet.x,bullet.y,bullet.difX,bullet.difY)
		bullet.speed = getDistance(bullet.x,bullet.y,bullet.difX,bullet.difY)
	end
	
end

function setPlayerVector()
	--set difference stuff
	local x1 = player.x+math.cos(player.dir)*player.velocity
	local y1 = player.y+math.sin(player.dir)*player.velocity

	--simulate difference
	for i, impulse in ipairs(impulses) do
		if impulse.id == 0 then
			--change the vector
			x1 = x1 + math.cos(impulse.dir)*impulse.intensity*hdt
			y1 = y1 + math.sin(impulse.dir)*impulse.intensity*hdt
			
			--remove impulse
			table.remove(impulses,i)
		end
	end
	
	--add difference to player vector
	player.dir = getAngle(player.x,player.y,x1,y1)
	player.velocity = getDistance(player.x,player.y,x1,y1)
end