function updateParticles()
	moveParticles()
	limitParticleCount()
	particleDecay()
	pickUpHealth()
	fuelParticles()
end

function moveParticles()
	for i, particle in ipairs(particles) do
		particle.x = particle.x + math.cos(particle.dir)*particle.velocity*hdt
		particle.y = particle.y + math.sin(particle.dir)*particle.velocity*hdt
	end
end

function limitParticleCount()
	local canRemove = false
	while getTableCount(particles) > 200 do
		canRemove = true
		for i, particle in ipairs(particles) do
			if particle.pType < 100 and canRemove then
				table.remove(particles,i)
				canRemove = false
			end
		end
	end
end

function particleDecay()
	for i, particle in ipairs(particles) do
		--set timer
		if particle.timer == nil then
			particle.timer = 0
		end
		particle.timer = particle.timer + hdt
		--decay
		if particle.timer > 10 then
			table.remove(particles,i)
		end
	end
end

function fuelParticles()
	local attractRadius = 150
	local attractIntensity = 200

	for i, particle in ipairs(particles) do
		if particle.pType == 101 then
			if player.health > 0 then
				--attract to player
				if getDistance(particle.x,particle.y,player.x,player.y) < attractRadius then
					particle.x = particle.x + (math.cos(getAngle(particle.x,particle.y,player.x,player.y))*attractIntensity*hdt)
					particle.y = particle.y + (math.sin(getAngle(particle.x,particle.y,player.x,player.y))*attractIntensity*hdt)
					--newImpulse = {dir = getAngle(player.x,player.y,particle.x,particle.y)-math.rad(90),intensity = (attractRadius-getDistance(particle.x,particle.y,player.x,player.y))*attractIntensity,id = particle.id} table.insert(impulses,newImpulse)
				end
				--pick up
				if getDistance(player.x,player.y,particle.x,particle.y) < (4+8) then
					table.remove(particles,i)
					player.fuel = player.fuel + 0.01
					player.totalFuel = player.totalFuel + 1
					--play audio
					a_blip:setPitch(fuelPitch)
					a_blip:setVolume(1*Avolume)
					la.play(a_blip:clone())
					fuelPitch = fuelPitch + 0.01
					fuelPitchTimer = 1.5
				end
			end
		end
	end
	
	--fuel pitch logic
	fuelPitchTimer = fuelPitchTimer - hdt
	if fuelPitchTimer < 0 then
		fuelPitch = 1
	end
end

function pickUpHealth()	--and weapons
	for i, particle in ipairs(particles) do
		if particle.pType == 100 then
			if getDistance(player.x,player.y,particle.x,particle.y) < (15+8) then
				if player.health == player.maxHealth then player.maxHealth = player.maxHealth + 1 end
				player.health = player.health + 1
				player.healthTimer = 0.6
				table.remove(particles,i)
				
				--play audio
				a_health:setPitch(math.random(85,115)/100)
				a_health:setVolume(1*Avolume)
				la.play(a_health:clone())
				
				--newWeapon
				if player.weapon == 11 then else
					player.shootTimer = 0
					player.pWeapon = player.weapon
					while player.weapon == player.pWeapon or player.weapon == 11 do
						player.weapon = math.random(1,getTableCount(weapons))
					end
				end
				
				--set ammount2
				for i, weapon in ipairs(weapons) do
					if i == player.weapon then
						player.ammount2 = weapon.ammount2
					end
				end
				
				
			end
		end
	end
end