function updatePlayer()
	updatePlayerMovement()
	controlPlayerThrust()
	playerFire()
	playerOutOfBounds()
	playerIFrames()
	killPlayer()
	playerRespawn()
	setWeaponColor()
	playerFrenzy()
	updateCamera()
	--settings stuff
	--setFullscreen()
	quit()
end

function updatePlayerMovement()
	player.x = player.x + math.cos(player.dir)*player.velocity*hdt
	player.y = player.y + math.sin(player.dir)*player.velocity*hdt
end

function controlPlayerThrust()
	--change dir
	if lk.isDown(controls.turnLeft) then
		player.thrusterdir = player.thrusterdir - (player.turnSpeed*hdt)
	end
	if lk.isDown(controls.turnRight) then
		player.thrusterdir = player.thrusterdir + (player.turnSpeed*hdt)
	end
	
	--set pFuel
	player.pFuel = player.fuel
	--accelerate
	if lk.isDown(controls.accelerate) and player.fuel > 0 and player.health > 0 then
		newImpulse = {dir = player.thrusterdir,intensity = player.thrusterPower,id = 0} table.insert(impulses,newImpulse)
		player.fuel = player.fuel - (hdt*0.15)
		player.turnSpeed = math.rad(90)
		--particles
		if thrustParticleTimer > 0.03 then
			local n = 5
			while n > 0 do
				newParticle = {id = math.random(1,10^21),x = player.x+math.random(-0.01,0.01)+math.cos(player.thrusterdir+math.rad(90))*5,y = player.y+math.random(-0.01,0.01)+math.sin(player.thrusterdir+math.rad(90))*5,dir = player.thrusterdir+math.rad(90)+math.rad(math.random(-10,10)),velocity = 50,pType = 1} table.insert(particles,newParticle)
				thrustParticleTimer = 0
				n = n - 1
			end
		end
	else
		if player.fuel < 0 then
			player.fuel = player.fuel + (hdt*0.2)
		elseif player.fuel < 1 then
			player.fuel = player.fuel + (hdt*0.02)
		end
		player.turnSpeed = math.rad(450)
	end
	
	--set negative fuel
	if player.fuel < 0 and player.pFuel > 0 then
		player.fuel = -0.35
	elseif player.fuel > 0 and player.pFuel < 0 then
		player.fuel = 0.2
	end
	
	--set fuel cap
	if player.fuel > 1 then
		player.fuel = 1
	end
	
	--set particle timer
	thrustParticleTimer = thrustParticleTimer + hdt
end

function fire(x1,y1,dir1,friendly1,damage1,ammount,accuracy,velocity, isProxRocket,radius1)
	local pr = false
	if isProxRocket then
		pr = true
	end
	local n = ammount
	while n > 0 do
		newBullet = {x = x1,y = y1,dir = dir1+math.rad(math.random(-accuracy,accuracy)),friendly = friendly1,damage = damage1,speed = velocity,id = math.random(1,10^21),isProxRocket = pr,radius = radius1} table.insert(bullets,newBullet)
		n = n - 1
	end
end

function playerFire()
	--setFireRate and weaponThrust
	for i, weapon in ipairs(weapons) do
		if player.weapon == i then
			player.maxShootTimer = weapon.firerate
			player.maxShootTimer3 = player.maxShootTimer
			player.maxShootTimer2 = weapon.firerate2
			player.weaponBackThrust = weapon.thrust
			player.maxAmmount2 = weapon.ammount2
			

		end
	end
	--fire
	if lk.isDown(controls.fire) and player.health > 0 then
		if player.shootTimer > player.maxShootTimer then
			--(x1,y1,dir1,friendly1,damage1,ammount,accuracy,velocity)
			for i, weapon in ipairs(weapons) do
				if player.weapon == i then
					if weapon.isLaser then else
						fire(player.x+(math.cos(player.thrusterdir-math.rad(90))*10),player.y+(math.sin(player.thrusterdir-math.rad(90))*10), player.thrusterdir-math.rad(90), true, weapon.damage,weapon.ammount,weapon.accuracy,weapon.velocity, player.proxRocket,player.weaponRadius)
					end
					--muzzle timer
					player.muzzleTimer = 0
				end
			end
			newImpulse = {dir = player.thrusterdir+math.rad(180),intensity = player.weaponBackThrust,id = 0} table.insert(impulses,newImpulse)
			if player.ammount2 > 1 then
				player.shootTimer = player.maxShootTimer-player.maxShootTimer2
				player.ammount2 = player.ammount2 - 1
			else
				player.shootTimer = 0
				player.ammount2 = player.maxAmmount2
			end
			--add screenshake
			if shakeFade < 2.5 then shakeFadeAmmount = 25 shakeFade = 2.5 end
			for i, weapon in ipairs(weapons) do
				if player.weapon == i then
					if weapon.isLaser then else
						--play normal audio
						a_fire1:setPitch(math.random(75,125)/100)
						a_fire1:setVolume(1*Avolume)
						la.play(a_fire1:clone())
					end
				end
			end
			
		end
	end
	
	--play laser audio
	if lk.isDown(controls.fire) and player.health > 0 then
		for i, weapon in ipairs(weapons) do
			if player.weapon == i then
				if weapon.isLaser then
					a_laser:setPitch(1)
					a_laser:setVolume(0.7*Avolume)
					la.play(a_laser)
				else
					la.stop(a_laser)
					la.stop(a_screech)
				end
			end
		end
	else
		la.stop(a_laser)
	end
	
	--update shootTimer
	for i, weapon in ipairs(weapons) do
		if i == player.weapon then
			if weapon.isCharge then 
				if lk.isDown(controls.fire) then
					player.shootTimer = player.shootTimer + hdt
				else
					if player.shootTimer < 0 then 
						player.shootTimer = 0
					else
						player.shootTimer = player.shootTimer - hdt
					end
				end
			else
				player.shootTimer = player.shootTimer + hdt
			end
		end
	end
	--update muzzleTimer
	player.muzzleTimer = player.muzzleTimer + hdt
end

function playerOutOfBounds()
	--update OutofBounds timer
	if player.x > PA.x and player.x < PA.x+PA.w and player.y > PA.y and player.y < PA.y+PA.h then
		if player.oobTimer < 1 then
			player.oobTimer = player.oobTimer + hdt
		end
	else
		if player.oobTimer > 0 then
			player.oobTimer = player.oobTimer - (0.1*hdt)
		end
	end
	
	--kill the player
	if player.oobTimer < 0 and player.health > 0 then
		player.health = 0
	end
end

function playerIFrames()
	--invin
	if player.hitTimer > 0 and player.health < player.pHealth then
		player.health = player.pHealth
	end
	--set timer
	if player.pHealth > player.health then
		player.hitTimer = 2
	end
	--timer
	player.hitTimer = player.hitTimer - hdt
end

function killPlayer()
	if player.health < 1 and player.health > -100 then
		--spawnParticles
		local n = 20
		while n > 0 do
			newParticle = {id = math.random(1,10^21),x = player.x+math.random(-10,10),y = player.y+math.random(-10,10),dir = 0,velocity = 0,pType = 0} table.insert(particles,newParticle)
			n = n - 1
		end
		--add explosion
		newExplosion = {x = player.x,y = player.y,radius = 100} table.insert(explosions,newExplosion)
		--add score
		local canScore = true
		for i, score in ipairs(scores) do	--check if score has already been added
			if score.new == 0 then
				canScore = false
			end
		end
		if canScore then
			newScore = {value = player.totalFuel, maxHealth = player.maxHealth, new = 0} table.insert(scores,newScore)
		end
		--save scores
		saveData.save(scores, "highscores")
		--set player health super low so that it won't spam explosions
		player.health = -1000
		player.pHealth = -1000
	end
	if player.health < 1 then
		--make sure new score is the same as the current one
		for i, score in ipairs(scores) do
			if score.new == 0 then
				player.totalFuel = score.value
			end
		end
		--stop player
		player.velocity = 0
		--prevent the game from spawning more enemies
		desiredEnemyCount = 0
		--stop the timer
		gameTimer = 0
	end
end

function playerFrenzy()
	player.pFrenzyTimer = player.frenzyTimer

	--activate frenzy
	if fuelPitch > 1.8 then
		player.pWeapon = player.weapon
		fuelPitch = 1
		player.frenzyTimer = 12.5
	end

	--update timer
	player.frenzyTimer = player.frenzyTimer - hdt
	
	--set frenzy stuff on first frame
	if player.frenzyTimer > 0 then
		player.weapon = 11
		player.fuel = player.fuel+(0.05*hdt)
		
		--remove fuel particles
		for i, particle in ipairs(particles) do
			if particle.pType == 101 then
				table.remove(particles,i)
			end
		end
		
		--play start audio
		if player.pFrenzyTimer < 0 then
			a_super:setPitch(1)
			a_super:setVolume(1*Avolume)
			la.play(a_super:clone())
		end
	elseif player.weapon == 11 then
		print("PW: "..player.pWeapon)
		player.weapon = player.pWeapon
	end
	
end

function setWeaponColor()
	if player.weapon == 1 then
		pColor = {r = 216,g = 202,b = 155}	--neutral
		sColor = {r = 141,g = 116,b = 60}	--bad
		tColor = {r = 89,g = 46,b = 63}	--good
		qColor = {r = 10,g = 3,b = 3}	--dark stuff
		i_player = i_player1
	elseif player.weapon == 2 then
		pColor = {r = 99,g = 237,b = 255}	--neutral
		sColor = {r = 255,g = 145,b = 226}	--bad
		tColor = {r = 250,g = 219,b = 255}	--good
		qColor = {r = 14,g = 35,b =38}	--dark stuff
		i_player = i_player2
	elseif player.weapon == 3 then
		pColor = {r = 255,g = 255/2,b = 255/4}	--neutral
		sColor = {r = 255,g = 255/2.3,b = 255/2.3}	--bad
		tColor = {r = 130,g = 0,b = 27}	--good
		qColor = {r = 10,g = 0,b = 0}	--dark stuff
		i_player = i_player3
	elseif player.weapon == 4 then
		pColor = {r = 255,g = 195,b = 0}	--neutral
		sColor = {r = 199,g = 0,b = 57}	--bad
		tColor = {r = 255,g = 87,b = 51}	--good
		qColor = {r = 10,g = 0,b = 10}	--dark stuff
		i_player = i_player4
	elseif player.weapon == 5 then
		pColor = {r = 82,g = 85,b = 152}	--neutral
		sColor = {r = 8,g = 147,b = 97}	--bad
		tColor = {r = 66,g = 143,b = 190}	--good
		qColor = {r = 0,g = 0,b = 10}	--dark stuff
		i_player = i_player5
	elseif player.weapon == 6 then
		pColor = {r = 143,g = 0,b = 62}	--neutral
		sColor = {r = 255,g = 20,b = 57}	--bad
		tColor = {r = 198,g = 151,b = 109}	--good
		qColor = {r = 10,g = 0,b = 0}	--dark stuff
		i_player = i_player6
	elseif player.weapon == 7 then
		pColor = {r = 109,g = 109,b = 44}	--neutral
		sColor = {r = 186,g = 70,b = 44}	--bad
		tColor = {r = 186,g = 163,b = 58}	--good
		qColor = {r = 5,g = 10,b = 0}	--dark stuff
		i_player = i_player7
	elseif player.weapon == 8 then
		pColor = {r = 98,g = 228,b = 96}	--neutral
		sColor = {r = 214,g = 252,b = 87}	--bad
		tColor = {r = 47,g = 158,b = 106}	--good
		qColor = {r = 20,g = 19,b = 29}	--dark stuff
		i_player = i_player8
	elseif player.weapon == 9 then
		pColor = {r = 255,g = 151,b = 35}	--neutral
		sColor = {r = 149,g = 230,b = 186}	--bad
		tColor = {r = 240,g = 180,b = 58}	--good
		qColor = {r = 15,g = 24,b = 25}	--dark stuff
		i_player = i_player9
	elseif player.weapon == 10 then
		pColor = {r = 0,g = 158,b = 165}	--neutral
		sColor = {r = 244,g = 240,b = 191}	--bad
		tColor = {r = 104,g = 118,b = 166}	--good
		qColor = {r = 31/1.6,g = 31/1.6,b = 39/1.6}	--dark stuff
		i_player = i_player10
	elseif player.weapon == 11 then
		pColor = {r = 216,g = 244,b = 187}	--neutral
		sColor = {r = 114,g = 104,b = 166}	--bad
		tColor = {r = 182,g = 206,b = 199}	--good
		qColor = {r = 68/2,g = 31/2,b = 63/2}	--dark stuff
		i_player = i_player11
	end
	
	--Set simple player image
	if settings.secretPlayer then
		i_player = i_playerSecret
	elseif settings.simplePlayer then
		i_player = i_playerSimple
	end
end

function playerRespawn()
	if player.health < 1 then
		if lk.isDown(controls.respawn) then
			--player stuff
			PA = {x = -4000,y = -4000,w = 8000,h = 8000}
			player.health = 5
			player.maxHealth = 5
			player.dir = math.rad(90)
			player.velocity = 0
			player.weapon = 1
			player.fuel = 1
			player.totalFuel = 0
			player.hitTimer = 3.5
			player.frenzyTimer = 0
			
			--tables and stuff that relates to said tables... or something I don't know.
			desiredEnemyCount = 100
			enemies = {}
			blackholes = {}
			explosions = {}
			particles = {}
			stars = {}
			bullets = {}
			
			--set new score to old
			for i, score in ipairs(scores) do
				score.new = 1
			end
			saveData.save(scores, "highscores")
			
			
		end
	end
end

function updateCamera()
	local dx = (player.x+math.cos(player.dir)*player.velocity/4)-(640/2)
	local dy = (player.y+math.sin(player.dir)*player.velocity/4)-(360/2)
	
	--set player position
	player.x = player.x - dx
	player.y = player.y - dy
	
	--updating everything else
	for i, enemy in ipairs(enemies) do
		enemy.x = enemy.x - dx
		enemy.y = enemy.y - dy
	end
	for i, bullet in ipairs(bullets) do
		bullet.x = bullet.x - dx
		bullet.y = bullet.y - dy
	end
	for i, star in ipairs(stars) do
		star.x = star.x - (dx*star.dist)
		star.y = star.y - (dy*star.dist)
	end
	for i, blackhole in ipairs(blackholes) do
		blackhole.x = blackhole.x - dx
		blackhole.y = blackhole.y - dy
	end
	for i, explosion in ipairs(explosions) do
		explosion.x = explosion.x - dx
		explosion.y = explosion.y - dy
	end
	for i, particle in ipairs(particles) do
		particle.x = particle.x - dx
		particle.y = particle.y - dy
	end
	
	--updatePlayableArea(PA)
	PA.x = PA.x - dx
	PA.y = PA.y - dy
	
end

function setFullscreen()
	function love.keypressed( key, isrepeat )
		if key == 'f' then
			if settings.fullscreen then
				settings.fullscreen = false
			else
				settings.fullscreen = true
			end
			love.window.setFullscreen(settings.fullscreen)
		end
	end
end
function quit()	--to menu
	if lk.isDown('escape') then
		player.health = 0
		gamestate = 'menu'
	end
end
function exitGame()
	--save scores
	if scores == nil then
		scores = saveData.load("highscores")
		if scores == nil then
			scores = {}
		end
	end
	--set new score to old
	for i, score in ipairs(scores) do
		score.new = 1
	end
	--save for reals
	saveData.save(scores, "highscores")
	--quit game
	love.event.quit()
end