function drawBullets()
	drawableBulletNils()
	setBulletColor()
	drawProjectiles()
	drawLaser()
end

function drawableBulletNils()
	for i, bullet in ipairs(bullets) do
		--timer
		if bullet.timer == nil then
			bullet.timer = 0
		end
		bullet.timer = bullet.timer + hdt
	end
end

function setBulletColor()
	for i, bullet in ipairs(bullets) do
		if bullet.friendly then
			bullet.r = pColor.r
			bullet.g = pColor.g
			bullet.b = pColor.b
		else
			bullet.r = sColor.r
			bullet.g = sColor.g
			bullet.b = sColor.b
		end
	end
end

function drawProjectiles()
	for i, bullet in ipairs(bullets) do
		--set img
		if bullet.isProxRocket then
			bullet.img = i_rocket
		else
			bullet.img = i_bullet1
		end
		
		--set scale
		local scale = 1
		if bullet.timer < 0.1 then
			scale = 1+(bullet.timer/0.1/2)
		end
		
		--draw bullet
		lg.setColor(bullet.r,bullet.g,bullet.b,255)
		lg.draw(bullet.img,bullet.x,bullet.y,bullet.dir+math.rad(90),0.8*scale,0.8/(scale),i_bullet1:getWidth()/2,i_bullet1:getHeight()/2)
		lg.setColor(bullet.r,bullet.g,bullet.b,255/2)
		lg.draw(bullet.img,bullet.x,bullet.y,bullet.dir+math.rad(90),1.25*scale+(math.sin(bullet.timer*30)*0.08),1.25/scale+(math.sin(bullet.timer*30)*0.08),i_bullet1:getWidth()/2,i_bullet1:getHeight()/2)
		
		--radius
		if bullet.radius == nil then else
			lg.setColor(bullet.r,bullet.g,bullet.b,255/3)
			lg.circle('line',bullet.x,bullet.y,bullet.radius+(math.cos(globalTimer*10)*3))
			lg.circle('line',bullet.x,bullet.y,bullet.radius+(math.cos(globalTimer*10)*3)-5)
		end
		
		lg.setColor(255,0,0)
	--	lg.rectangle('line',bullet.x-8,bullet.y-8,16,16)
	end
end

function drawLaser()
	for i, weapon in ipairs(weapons) do
		if i == player.weapon and weapon.isLaser and player.health > 0 then
			if lk.isDown(controls.fire) then
				lg.setColor(pColor.r,pColor.g,pColor.b,255*100)
				lg.setLineWidth(8+(math.sin(globalTimer*65))*2.5)
				lg.line(player.x+math.cos(player.thrusterdir-math.rad(90))*7,player.y+math.sin(player.thrusterdir-math.rad(90))*7, player.x+math.cos(player.thrusterdir-math.rad(90))*2000,player.y+math.sin(player.thrusterdir-math.rad(90))*2000)
				
				lg.setColor(pColor.r,pColor.g,pColor.b,255/2)
				lg.setLineWidth(16+(math.sin(globalTimer*65))*2.5)
				lg.line(player.x+math.cos(player.thrusterdir-math.rad(90))*7,player.y+math.sin(player.thrusterdir-math.rad(90))*7, player.x+math.cos(player.thrusterdir-math.rad(90))*2000,player.y+math.sin(player.thrusterdir-math.rad(90))*2000)
				lg.setLineWidth(1)
			end
		end
	end
end