function drawEnemies()
	drawAsteroids()
	drawFighter()
	drawHunter()
	drawMine()
	updateEnemyHit()
end

function drawAsteroids()
	for i, enemy in ipairs(enemies) do
		if enemy.x > -15 and enemy.x < 640+15 and enemy.y > - 15 and enemy.y < 360+15 then
			if enemy.eType == 0 or enemy.eType == 2 then
				--set color for explosive
				if enemy.eType == 2 then
					enemy.g = sColor.g
					enemy.b = sColor.b
					enemy.r = sColor.r
				else
					enemy.g = pColor.g
					enemy.b = pColor.b
					enemy.r = pColor.r
				end
				--set rotation
				if enemy.rot == nil or enemy.rotSpeed == nil then
					enemy.rot = math.rad(math.random(0,360))
					enemy.rotSpeed = math.rad(math.random(-130,130))
				end
				enemy.rot = enemy.rot + (enemy.rotSpeed*hdt)
				
				--set Image
				if enemy.img == nil then
					local n = math.random(1,5)
					if n == 1 then
						enemy.img = i_asteroid
					elseif n == 2 then
						enemy.img = i_asteroid2
					elseif n == 3 then
						enemy.img = i_asteroid3
					elseif n == 4 then
						enemy.img = i_asteroid4
					else
						enemy.img = i_asteroid5
					end
				end
				
				
				lg.setColor(enemy.r,enemy.g,enemy.b)
				lg.draw(enemy.img,enemy.x,enemy.y, enemy.rot, 1+(enemy.hit*5),1+(enemy.hit*5), i_asteroid:getWidth()/2,i_asteroid:getHeight()/2)
				
				lg.setColor(sColor.r,sColor.g,sColor.b)
			--	lg.rectangle('line',enemy.x-8,enemy.y-8,16,16)
			end
		end
	end
end

function drawFighter()
	for i, enemy in ipairs(enemies) do
		if enemy.eType == 1 then
			if enemy.x > -15 and enemy.x < 640+15 and enemy.y > - 15 and enemy.y < 360+15 then
				--set rotation
				if enemy.rot == nil or enemy.rotSpeed == nil then
					enemy.rot = math.rad(math.random(0,360))
					enemy.rotSpeed = math.rad(math.random(-130,130))
				end
				
			
				lg.setColor(sColor.r,sColor.g,sColor.b)
				lg.draw(i_fighter,enemy.x,enemy.y, enemy.dir+math.rad(90), 1+(enemy.hit*5),1+(enemy.hit*5), i_asteroid:getWidth()/2,i_asteroid:getHeight()/2)
				
				lg.setColor(sColor.r,sColor.g,sColor.b)
			--	lg.rectangle('line',enemy.x-8,enemy.y-8,16,16)
			end
		end
	end
end

function drawHunter()
	for i, enemy in ipairs(enemies) do
		if enemy.eType == 3 then
			if enemy.x > -15 and enemy.x < 640+15 and enemy.y > - 15 and enemy.y < 360+15 then
				lg.setColor(sColor.r,sColor.g,sColor.b)
				lg.draw(i_hunter,enemy.x,enemy.y, enemy.dir+math.rad(90), 1+(enemy.hit*5),1+(enemy.hit*5), i_asteroid:getWidth()/2,i_asteroid:getHeight()/2)
				--draw cannon
				lg.setColor(sColor.r,sColor.g,sColor.b)
				lg.draw(i_cannon,enemy.x,enemy.y, getAngle(player.x,player.y,enemy.x,enemy.y)-math.rad(90), 1+(enemy.hit*5),1+(enemy.hit*5), i_asteroid:getWidth()/2,i_asteroid:getHeight())
			end
		end
	end
end

function drawMine()
	for i, enemy in ipairs(enemies) do
		if enemy.eType == 4 then
			if enemy.x > -150 and enemy.x < 640+150 and enemy.y > - 150 and enemy.y < 360+150 then
				--set rotation
				if enemy.rot == nil or enemy.rotSpeed == nil then
					enemy.rot = math.rad(math.random(0,360))
					enemy.rotSpeed = math.rad(math.random(-130,130))
				end
				enemy.rot = enemy.rot + (enemy.rotSpeed*hdt)
			
				lg.setColor(sColor.r,sColor.g,sColor.b)
				lg.draw(i_mine,enemy.x,enemy.y, enemy.rot, 1+(enemy.hit*5),1+(enemy.hit*5), i_asteroid:getWidth()/2,i_asteroid:getHeight()/2)
				--radius
				lg.setColor(sColor.r,sColor.g,sColor.b,255*1000)
				enemy.radius = 75
				if enemy.aTimer == nil then enemy.aTimer = 0.75 end
				lg.circle('line',enemy.x,enemy.y, enemy.radius,100)
				lg.setColor(sColor.r,sColor.g,sColor.b,200-(255*enemy.aTimer))
				lg.circle('fill',enemy.x,enemy.y, enemy.radius,100)
			end
		end
	end
end

function updateEnemyHit()
	for i, enemy in ipairs(enemies) do
		if enemy.hit > 0 then
			enemy.hit = enemy.hit - hdt
		end
	end
end