function drawHUD()
	drawHUDCanvas()
end

function drawHUDCanvas()
	lg.setCanvas(c_hudShadow)
	lg.clear()
		drawChevron()
		drawOutOfBoundsElipse()
		removeColorsIfOutOfBounds()
		drawHealth()
		drawFuel()
		drawDarkBox()
		drawRespawnText()
	lg.setCanvas(maid64.canvas)
	
	--draw the shadow
--	for i=100,1,-1 do
--		lg.setColor(255/2-i,255/2-i,255/2-i,255)
--		lg.draw(c_hudShadow,(i/15)*math.cos(globalTimer*4),(i/15)*math.sin(globalTimer*4))
--	end
	--draw the hud
	lg.setColor(255,255,255)
	lg.draw(c_hudShadow,0,0)
end

function drawChevron()
	if player.x > PA.x and player.x < PA.x+PA.w and player.y > PA.y and player.y < PA.y+PA.h then else
		if player.health > 0 then
			lg.setColor(pColor.r,pColor.g,pColor.b)
			local angle = getAngle(player.x,player.y,PA.x+(PA.w)/2,PA.y+(PA.h)/2)
			lg.draw(i_chevron,player.x+math.cos(angle)*65,player.y+math.sin(angle)*65, angle+math.rad(90), 0.25,0.25, i_chevron:getWidth()/2,i_chevron:getHeight()/2)
		end
	end
end

function removeColorsIfOutOfBounds()
	if player.x > PA.x and player.x < PA.x+PA.w and player.y > PA.y and player.y < PA.y+PA.h then else
		lg.setColor(sColor.r,sColor.g,sColor.b,255/4)
		lg.rectangle('fill',0,0,640,360)
	end
end

function drawHealth()
	local n = 0
	while n < player.maxHealth do
		if player.health > n then
			lg.setColor(pColor.r,pColor.g,pColor.b)
			lg.draw(i_heart,10+17.5*n,10, math.sin(globalTimer*3+math.rad(n*70))/6, 0.25*(player.healthTimer*1+1),0.25*(player.healthTimer*1+1), i_heart:getWidth()/2,i_heart:getHeight()/2)
		else
			lg.setColor(sColor.r,sColor.g,sColor.b)
			lg.draw(i_cross,10+17.5*n,10, math.sin(globalTimer*3+math.rad(n*70))/6, 0.25*(player.healthTimer*1+1),0.25*(player.healthTimer*1+1), i_heart:getWidth()/2,i_heart:getHeight()/2)
		end
		n = n + 1
	end
	if player.healthTimer > 0 then
		player.healthTimer = player.healthTimer - hdt
	end
end

function drawFuel()
	--draw bar
	local n = 1
	local angle = math.rad(60)-math.rad(90)
	while n > 0 do
		if n < -player.fuel then
			lg.setColor(sColor.r,sColor.g,sColor.b,255*10)
		else
			if n < player.fuel then
				lg.setColor(pColor.r,pColor.g,pColor.b,255*100)
			else
				if n < 0.2 then
					lg.setColor(pColor.r/3.64,pColor.g/3.64,pColor.b/3.64,255*100)
				elseif n < 0.35 then
					lg.setColor(sColor.r/5.1,sColor.g/25.5,sColor.b/25.5,255*100)
				else
					lg.setColor(pColor.r/8.5,pColor.g/8.5,pColor.b/8.5,255*100)
				end
			end
		end
		angle = angle + math.rad(60*0.01)
		lg.line(570+math.cos(angle*2)*40,300+math.sin(angle*2)*40, 570+math.cos(angle*2)*47,300+math.sin(angle*2)*47)
		n = n - 0.01
	end
	
	--draw icon
	if n < -player.fuel then
		lg.setColor(sColor.r,sColor.g,sColor.b,255*10)
	else
		lg.setColor(pColor.r,pColor.g,pColor.b,255*10)
	end
	lg.draw(i_fuel,580,300, math.cos(globalTimer)/3, 0.35*(player.visualFuelTimer*3+1),0.35*(player.visualFuelTimer*3+1),i_fuel:getWidth()/2,i_fuel:getHeight()/2)
	if player.visualFuelTimer > 0 then
		player.visualFuelTimer = player.visualFuelTimer - hdt
	end
	
	--draw totalFuel(sorta like score)
	if scores == nil then
		if scores == nil then
			scores = {}
		end
	end
	local high = 0
	for i, score in ipairs(scores) do
		if i == 1 then high = score.value end
	end
	if player.totalFuel > high then
		lg.setColor(sColor.r,sColor.g,sColor.b,255*1000)
		lg.print('New High!',520,20, 0, 1.1,1.1)
	end
	lg.setColor(pColor.r,pColor.g,pColor.b,255*1000)
	lg.print('Score: '..player.totalFuel,520,5, 0, 1.1,1.1)
	
end

function drawRespawnText()
	if player.health < 1 then
		--save scores stuff
		if scores == nil then
			if scores == nil then
				scores = {}
			end
		end
	
		--set color
		lg.setColor(pColor.r,pColor.g,pColor.b,255*1000)
		--respawn text
		lg.print("You're dead. Press '"..controls.respawn.."' to respawn.",200,320)
		--high scores
		lg.print("Highscores:",267.5,95, 0, 1.2,1.2)
		
		--update scores
		scores = saveData.load("highscores")
		
		--current score
		for i, score in ipairs(scores) do
			if score.new == 0 then
				lg.print("Current score: "..score.value,235,65, 0, 1.2,1.2)
			end
		end
		
		--sort score
		sort = function(score1, score2)
			return score1.value > score2.value
		end
		table.sort(scores, sort)
		
		--draw highscores
		local newString = ""
		for i, score in ipairs(scores) do
		newString = ""
			if i <= 9 then
				--new text
				if score.new == 0 then
					newString = " New!"
				end
				--highscore text
				lg.setColor(pColor.r,pColor.g,pColor.b,255*1000)
				lg.print(i..":",267.5,105+(i*15), 0, 1.2,1.2)
				lg.setColor(sColor.r,sColor.g,sColor.b,255*1000)
				lg.print(score.value..newString,267.5+20,105+(i*15), 0, 1.2,1.2)
			end
		end
		
	end
end

function drawDarkBox()
	if player.health < 1 then
		lg.setColor(0,0,0,255/2.5)
		lg.rectangle('fill',0,0, 640,360)
	end
end

function drawOutOfBoundsElipse()	--not actaully an elipse anymore...
	if player.x > PA.x and player.x < PA.x+PA.w and player.y > PA.y and player.y < PA.y+PA.h then else
		if player.health > 0 then
			lg.setColor(pColor.r,pColor.g,pColor.b)
			lg.rectangle('fill',player.x-40,player.y-25,1,6)
			lg.rectangle('fill',player.x+40,player.y-25,1,6)
			lg.rectangle('fill',player.x-40,player.y-25+1,80-(player.oobTimer*80),6-2)
		end
		
	end
end