function drawParticles()
	setParticleAlphaTimer()
	setParticleRotation()
	drawFuelParticles()
	drawDebris()
	drawFlames()
	drawBulletHit()
	drawHealthPack()
end

function setParticleRotation()
	for i, particle in ipairs(particles) do
		--setup
		if particle.rot == nil then
			particle.rot = math.rad(math.random(0,360))
			particle.rotSpeed = math.random(-40,40)
		end
		--update
		particle.rot = particle.rot + (particle.rotSpeed*hdt)
	end
end

function setParticleAlphaTimer()
	for i, particle in ipairs(particles) do
		if particle.alphaTimer == nil then
			particle.alphaTimer = 1
		end
		particle.alphaTimer = particle.alphaTimer-hdt
	end
end

function drawDebris()
	for i, particle in ipairs(particles) do
		if particle.pType == 0 then
			if particle.x > -15 and particle.x < 640+15 and particle.y > - 15 and particle.y < 360+15 then
				lg.setColor(qColor.r*3+7.5,qColor.g*3+7.5,qColor.b*3+7.5,(10-particle.timer)*255)
				lg.draw(i_debris,particle.x,particle.y,particle.rot,1/2,1/2,i_debris:getWidth()/2,i_debris:getHeight()/2)
			end
		end
	end
end

function drawFlames()
	for i, particle in ipairs(particles) do
		if particle.pType == 1 then
			if particle.x > -15 and particle.x < 640+15 and particle.y > - 15 and particle.y < 360+15 then
				lg.setColor((pColor.r*particle.alphaTimer)+qColor.r,(pColor.g*particle.alphaTimer)+qColor.g,(pColor.b*particle.alphaTimer)+qColor.b,255*10)
				lg.draw(i_flames,particle.x,particle.y,particle.rot,0.75/2,0.75/2,i_debris:getWidth()/2,i_debris:getHeight()/2)
				--remove the particle
				if particle.alphaTimer < 0 then
					table.remove(particles,i)
				end
			end
		end
	end
end

function drawFuelParticles()
	for i, particle in ipairs(particles) do
		if particle.pType == 101 then
			if particle.x > -15 and particle.x < 640+15 and particle.y > - 15 and particle.y < 360+15 then
				lg.setColor(sColor.r,sColor.g,sColor.b,255/2)
				lg.draw(i_fuelParticle,particle.x,particle.y,particle.rot,0.75,0.75,i_debris:getWidth()/2,i_debris:getHeight()/2)
				lg.setColor(sColor.r,sColor.g,sColor.b,255*1000)
				lg.draw(i_fuelParticle,particle.x,particle.y,particle.rot,1/2,1/2,i_debris:getWidth()/2,i_debris:getHeight()/2)
			end
		end
	end
end

function drawBulletHit()
	for i, particle in ipairs(particles) do
		if particle.pType == 2 or particle.pType == 3 then
			if particle.x > -15 and particle.x < 640+15 and particle.y > - 15 and particle.y < 360+15 then
				--limit alpha timer
				if particle.alphaTimer > 0.25 then
					particle.alphaTimer = 0.25
				end
				
				if particle.pType == 2 then
					lg.setColor((pColor.r*particle.alphaTimer*4)+qColor.r,(pColor.g*particle.alphaTimer*4)+qColor.g,(pColor.b*particle.alphaTimer*4)+qColor.b,255*10)
				else
					lg.setColor((sColor.r*particle.alphaTimer*4)+qColor.r,(sColor.g*particle.alphaTimer*4)+qColor.g,(sColor.b*particle.alphaTimer*4)+qColor.b,255*10)
				end
				lg.draw(i_flames,particle.x,particle.y,particle.rot,0.75/4,0.75/4,i_debris:getWidth()/2,i_debris:getHeight()/2)
				--remove the particle
				if particle.alphaTimer < 0 then
					table.remove(particles,i)
				end
			end
		end
	end
end

function drawHealthPack()
	for i, particle in ipairs(particles) do
		if particle.pType == 100 then
			if particle.x > -15 and particle.x < 640+15 and particle.y > - 15 and particle.y < 360+15 then
				lg.setColor(tColor.r,tColor.g,tColor.b,255*10)
				if particle.timer > 8.5 then
					lg.setColor(tColor.r,tColor.g,tColor.b,(math.sin(globalTimer*30)+1)*255)
				elseif particle.timer > 7 then
					lg.setColor(tColor.r,tColor.g,tColor.b,(math.sin(globalTimer*15)+1)*255)
				else
					lg.setColor(tColor.r,tColor.g,tColor.b,255*10)
				end
				lg.draw(i_heart,particle.x,particle.y,particle.rot/8,0.25,0.25,i_heart:getWidth()/2,i_heart:getHeight()/2)
				lg.circle('line',particle.x,particle.y,15+(math.sin(globalTimer*4)*2),100)
			end
		end
	end
end