function drawPlayer()
	if player.health > 0 then
		drawPlayerCharge()
		drawPlayerShip()
		drawPlayerMuzzleFlash()
	end
end

function drawPlayerShip()
	if player.hitTimer > 0 then
		lg.setColor(pColor.r,pColor.g,pColor.b,(math.sin(globalTimer*15)+1)*(255/3))
	else
		lg.setColor(pColor.r,pColor.g,pColor.b)
	end
	lg.draw(i_player,player.x,player.y, player.thrusterdir, 1,1, i_player:getWidth()/2,i_player:getHeight()/2)
end

function drawPlayerMuzzleFlash()
	--draw flash onto canvas
	lg.setCanvas(c_playerMuzzleFlash)
	lg.clear()
		if player.muzzleTimer < 0.065 then
			lg.setColor(pColor.r,pColor.g,pColor.b,255/2)
			lg.ellipse('fill',200,200, (player.muzzleTimer*150+10)*4,(player.muzzleTimer*150+10)*4, 100)
			lg.setColor(pColor.r,pColor.g,pColor.b,255*10)
			lg.ellipse('fill',200,200, (player.muzzleTimer*150+10)*2,(player.muzzleTimer*150+10)*2.25, 100)
		elseif player.muzzleTimer < 0.1 then
			lg.setColor(pColor.r,pColor.g,pColor.b,255/2)
			lg.ellipse('fill',200,200, (17.5+(player.muzzleTimer*30))*4.5,(17.5-(player.muzzleTimer*200+10))*3.5, 100)
			lg.setColor(pColor.r,pColor.g,pColor.b,255*10)
			lg.ellipse('fill',200,200, (17.5+(player.muzzleTimer*30))*2.5,(17.5-(player.muzzleTimer*200+10))*1.75, 100)
		end
	lg.setCanvas(maid64.canvas)
	
	--draw canvas
	lg.setColor(255,255,255)
	lg.draw(c_playerMuzzleFlash,player.x+math.cos(player.thrusterdir-math.rad(90))*10,player.y+math.sin(player.thrusterdir-math.rad(90))*10, player.thrusterdir, 0.3,0.3, c_playerMuzzleFlash:getWidth()/2,c_playerMuzzleFlash:getHeight()/2)
end

function drawPlayerCharge()
	for i, weapon in ipairs(weapons) do
		if i == player.weapon then
			if weapon.isCharge then
				--draw flash onto canvas
				lg.setCanvas(c_playerChargeFlash)
				lg.clear()
					lg.setColor(pColor.r,pColor.g,pColor.b,255/2)
					lg.draw(i_player,player.x,player.y, player.thrusterdir, 1+(player.shootTimer*0.1),1+(player.shootTimer*0.1), i_player:getWidth()/2,i_player:getHeight()/2)
				lg.setCanvas(maid64.canvas)
				
				--draw canvas
				--lg.setColor(255,255,255)
				--lg.draw(c_playerChargeFlash,player.x,player.y, player.thrusterdir, 1,1, c_playerMuzzleFlash:getWidth()/2,c_playerMuzzleFlash:getHeight()/2)
				if player.shootTimer == 0 then else
					lg.setColor(pColor.r,pColor.g,pColor.b,255/2)
					lg.draw(i_player,player.x,player.y, player.thrusterdir, 1+(player.shootTimer*0.55)+(math.sin(globalTimer*23)*0.08),1+(player.shootTimer*0.55)+(math.sin(globalTimer+math.rad(180)*23)*0.08), i_player:getWidth()/2,i_player:getHeight()/2)
				end
				
			end
		end
	end
end