function drawSettingsMenu()
	drawButtons()
	drawButtonControlText()
	drawSettingsText()
	drawSettingsSelect()
	drawCursor()
end

function drawSettingsText()
	--Fullscreen text
	lg.setColor(247,237,147,255*1000)
	lg.print("Fullscreen",10,10, 0, 2,2)
	
	--SimplePlayer text
	lg.setColor(247,237,147,255*1000)
	lg.print("Player",10,140, 0, 1.8,1.8)
	
	--controls text
	lg.setColor(247,237,147,255*1000)
	lg.print("Controls",425,10, 0, 1.8,1.8)
end

function drawSettingsSelect()
	for i, button in ipairs(buttons) do
		--Fullscreen select
		if settings.fullscreen and button.id == 4 then
			lg.setColor(247,237,147,255*1000)
			lg.draw(i_select,button.x,button.y, 0, button.scale,button.scale, button.img:getWidth()/2,button.img:getHeight()/2)
		elseif settings.fullscreen == false and button.id == 5 then
			lg.setColor(247,237,147,255*1000)
			lg.draw(i_select,button.x,button.y, 0, button.scale,button.scale, button.img:getWidth()/2,button.img:getHeight()/2)
		end
		
		--Simple Player select
		if settings.secretPlayer then
			if button.id == 69 then
				lg.setColor(247,237,147,255*1000)
				lg.draw(i_select,button.x,button.y, 0, button.scale,button.scale, button.img:getWidth()/2,button.img:getHeight()/2)
			end
		else
			if settings.simplePlayer == false and button.id == 6 then
				lg.setColor(247,237,147,255*1000)
				lg.draw(i_select,button.x,button.y, 0, button.scale,button.scale, button.img:getWidth()/2,button.img:getHeight()/2)
			elseif settings.simplePlayer and button.id == 7 then
				lg.setColor(247,237,147,255*1000)
				lg.draw(i_select,button.x,button.y, 0, button.scale,button.scale, button.img:getWidth()/2,button.img:getHeight()/2)
			end
		end
		
	end
end

function drawButtonControlText()
	for i, button in ipairs(buttons) do
		if button.state == gamestate then
			--check hover(and set the color)
			if collision(mouse.x/2,mouse.y/2,0.01,0.01, button.x-(button.img:getWidth()/2*button.scale),button.y-(button.img:getHeight()/2*button.scale),button.img:getWidth()*button.scale,button.img:getHeight()*button.scale) then
				lg.setColor(247,237,147,255*1000)
				button.isHover = true
			else
				lg.setColor(87,61,217,255*1000)
				button.isHover = false
			end
			
			--draw the text
			if button.id == 8 then
				lg.print('"'..controls.turnLeft..'"', button.x+button.img:getWidth()+15,button.y-10, 0, 2,2)
			elseif button.id == 9 then
				lg.print('"'..controls.turnRight..'"', button.x+button.img:getWidth()+15,button.y-10, 0, 2,2)
			elseif button.id == 10 then
				lg.print('"'..controls.accelerate..'"', button.x+button.img:getWidth()+15,button.y-10, 0, 2,2)
			elseif button.id == 11 then
				lg.print('"'..controls.fire..'"', button.x+button.img:getWidth()+15,button.y-10, 0, 2,2)
			end
		end
	end
end